package com.hfkj.dao;

import com.hfkj.entity.BsTradeOrderProfitSharing;
import com.hfkj.entity.BsTradeOrderProfitSharingExample.Criteria;
import com.hfkj.entity.BsTradeOrderProfitSharingExample.Criterion;
import com.hfkj.entity.BsTradeOrderProfitSharingExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class BsTradeOrderProfitSharingSqlProvider {

    public String countByExample(BsTradeOrderProfitSharingExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("bs_trade_order_profit_sharing");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(BsTradeOrderProfitSharingExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("bs_trade_order_profit_sharing");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(BsTradeOrderProfitSharing record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("bs_trade_order_profit_sharing");
        
        if (record.getCmdType() != null) {
            sql.VALUES("cmd_type", "#{cmdType,jdbcType=INTEGER}");
        }
        
        if (record.getTradeOrderId() != null) {
            sql.VALUES("trade_order_id", "#{tradeOrderId,jdbcType=BIGINT}");
        }
        
        if (record.getTradeOrderNo() != null) {
            sql.VALUES("trade_order_no", "#{tradeOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getOriginProfitSharingOrderNo() != null) {
            sql.VALUES("origin_profit_sharing_order_no", "#{originProfitSharingOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getProfitSharingOrderNo() != null) {
            sql.VALUES("profit_sharing_order_no", "#{profitSharingOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getPlatformType() != null) {
            sql.VALUES("platform_type", "#{platformType,jdbcType=INTEGER}");
        }
        
        if (record.getPlatformProfitSharingOrderNo() != null) {
            sql.VALUES("platform_profit_sharing_order_no", "#{platformProfitSharingOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getPlatformMerNo() != null) {
            sql.VALUES("platform_mer_no", "#{platformMerNo,jdbcType=VARCHAR}");
        }
        
        if (record.getPlatformTradeNo() != null) {
            sql.VALUES("platform_trade_no", "#{platformTradeNo,jdbcType=VARCHAR}");
        }
        
        if (record.getPlatformAppid() != null) {
            sql.VALUES("platform_appid", "#{platformAppid,jdbcType=VARCHAR}");
        }
        
        if (record.getRatio() != null) {
            sql.VALUES("ratio", "#{ratio,jdbcType=DECIMAL}");
        }
        
        if (record.getProfitSharingAmoun() != null) {
            sql.VALUES("profit_sharing_amoun", "#{profitSharingAmoun,jdbcType=DECIMAL}");
        }
        
        if (record.getStatus() != null) {
            sql.VALUES("`status`", "#{status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateType() != null) {
            sql.VALUES("create_type", "#{createType,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.VALUES("create_time", "#{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getProfitSharingTime() != null) {
            sql.VALUES("profit_sharing_time", "#{profitSharingTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getFinishTime() != null) {
            sql.VALUES("finish_time", "#{finishTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(BsTradeOrderProfitSharingExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("cmd_type");
        sql.SELECT("trade_order_id");
        sql.SELECT("trade_order_no");
        sql.SELECT("origin_profit_sharing_order_no");
        sql.SELECT("profit_sharing_order_no");
        sql.SELECT("platform_type");
        sql.SELECT("platform_profit_sharing_order_no");
        sql.SELECT("platform_mer_no");
        sql.SELECT("platform_trade_no");
        sql.SELECT("platform_appid");
        sql.SELECT("ratio");
        sql.SELECT("profit_sharing_amoun");
        sql.SELECT("`status`");
        sql.SELECT("create_type");
        sql.SELECT("create_time");
        sql.SELECT("profit_sharing_time");
        sql.SELECT("finish_time");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.FROM("bs_trade_order_profit_sharing");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        BsTradeOrderProfitSharing record = (BsTradeOrderProfitSharing) parameter.get("record");
        BsTradeOrderProfitSharingExample example = (BsTradeOrderProfitSharingExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("bs_trade_order_profit_sharing");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getCmdType() != null) {
            sql.SET("cmd_type = #{record.cmdType,jdbcType=INTEGER}");
        }
        
        if (record.getTradeOrderId() != null) {
            sql.SET("trade_order_id = #{record.tradeOrderId,jdbcType=BIGINT}");
        }
        
        if (record.getTradeOrderNo() != null) {
            sql.SET("trade_order_no = #{record.tradeOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getOriginProfitSharingOrderNo() != null) {
            sql.SET("origin_profit_sharing_order_no = #{record.originProfitSharingOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getProfitSharingOrderNo() != null) {
            sql.SET("profit_sharing_order_no = #{record.profitSharingOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getPlatformType() != null) {
            sql.SET("platform_type = #{record.platformType,jdbcType=INTEGER}");
        }
        
        if (record.getPlatformProfitSharingOrderNo() != null) {
            sql.SET("platform_profit_sharing_order_no = #{record.platformProfitSharingOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getPlatformMerNo() != null) {
            sql.SET("platform_mer_no = #{record.platformMerNo,jdbcType=VARCHAR}");
        }
        
        if (record.getPlatformTradeNo() != null) {
            sql.SET("platform_trade_no = #{record.platformTradeNo,jdbcType=VARCHAR}");
        }
        
        if (record.getPlatformAppid() != null) {
            sql.SET("platform_appid = #{record.platformAppid,jdbcType=VARCHAR}");
        }
        
        if (record.getRatio() != null) {
            sql.SET("ratio = #{record.ratio,jdbcType=DECIMAL}");
        }
        
        if (record.getProfitSharingAmoun() != null) {
            sql.SET("profit_sharing_amoun = #{record.profitSharingAmoun,jdbcType=DECIMAL}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateType() != null) {
            sql.SET("create_type = #{record.createType,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getProfitSharingTime() != null) {
            sql.SET("profit_sharing_time = #{record.profitSharingTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getFinishTime() != null) {
            sql.SET("finish_time = #{record.finishTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("bs_trade_order_profit_sharing");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("cmd_type = #{record.cmdType,jdbcType=INTEGER}");
        sql.SET("trade_order_id = #{record.tradeOrderId,jdbcType=BIGINT}");
        sql.SET("trade_order_no = #{record.tradeOrderNo,jdbcType=VARCHAR}");
        sql.SET("origin_profit_sharing_order_no = #{record.originProfitSharingOrderNo,jdbcType=VARCHAR}");
        sql.SET("profit_sharing_order_no = #{record.profitSharingOrderNo,jdbcType=VARCHAR}");
        sql.SET("platform_type = #{record.platformType,jdbcType=INTEGER}");
        sql.SET("platform_profit_sharing_order_no = #{record.platformProfitSharingOrderNo,jdbcType=VARCHAR}");
        sql.SET("platform_mer_no = #{record.platformMerNo,jdbcType=VARCHAR}");
        sql.SET("platform_trade_no = #{record.platformTradeNo,jdbcType=VARCHAR}");
        sql.SET("platform_appid = #{record.platformAppid,jdbcType=VARCHAR}");
        sql.SET("ratio = #{record.ratio,jdbcType=DECIMAL}");
        sql.SET("profit_sharing_amoun = #{record.profitSharingAmoun,jdbcType=DECIMAL}");
        sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        sql.SET("create_type = #{record.createType,jdbcType=INTEGER}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("profit_sharing_time = #{record.profitSharingTime,jdbcType=TIMESTAMP}");
        sql.SET("finish_time = #{record.finishTime,jdbcType=TIMESTAMP}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        
        BsTradeOrderProfitSharingExample example = (BsTradeOrderProfitSharingExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(BsTradeOrderProfitSharing record) {
        SQL sql = new SQL();
        sql.UPDATE("bs_trade_order_profit_sharing");
        
        if (record.getCmdType() != null) {
            sql.SET("cmd_type = #{cmdType,jdbcType=INTEGER}");
        }
        
        if (record.getTradeOrderId() != null) {
            sql.SET("trade_order_id = #{tradeOrderId,jdbcType=BIGINT}");
        }
        
        if (record.getTradeOrderNo() != null) {
            sql.SET("trade_order_no = #{tradeOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getOriginProfitSharingOrderNo() != null) {
            sql.SET("origin_profit_sharing_order_no = #{originProfitSharingOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getProfitSharingOrderNo() != null) {
            sql.SET("profit_sharing_order_no = #{profitSharingOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getPlatformType() != null) {
            sql.SET("platform_type = #{platformType,jdbcType=INTEGER}");
        }
        
        if (record.getPlatformProfitSharingOrderNo() != null) {
            sql.SET("platform_profit_sharing_order_no = #{platformProfitSharingOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getPlatformMerNo() != null) {
            sql.SET("platform_mer_no = #{platformMerNo,jdbcType=VARCHAR}");
        }
        
        if (record.getPlatformTradeNo() != null) {
            sql.SET("platform_trade_no = #{platformTradeNo,jdbcType=VARCHAR}");
        }
        
        if (record.getPlatformAppid() != null) {
            sql.SET("platform_appid = #{platformAppid,jdbcType=VARCHAR}");
        }
        
        if (record.getRatio() != null) {
            sql.SET("ratio = #{ratio,jdbcType=DECIMAL}");
        }
        
        if (record.getProfitSharingAmoun() != null) {
            sql.SET("profit_sharing_amoun = #{profitSharingAmoun,jdbcType=DECIMAL}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateType() != null) {
            sql.SET("create_type = #{createType,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getProfitSharingTime() != null) {
            sql.SET("profit_sharing_time = #{profitSharingTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getFinishTime() != null) {
            sql.SET("finish_time = #{finishTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, BsTradeOrderProfitSharingExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}